- [HTTP request](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#body.request_body)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#body.response_body)
- [Authorization scopes](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#body.aspect)
- [DateDimensionGranularity](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#DateDimensionGranularity)
- [GoogleAdsDimensions](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#GoogleAdsDimensions)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#GoogleAdsDimensions.SCHEMA_REPRESENTATION)
- [MetricType](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#MetricType)
- [Dv360Dimensions](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#Dv360Dimensions)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#Dv360Dimensions.SCHEMA_REPRESENTATION)
- [YouTubeReserveDimensions](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#YouTubeReserveDimensions)
  - [JSON representation](https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#YouTubeReserveDimensions.SCHEMA_REPRESENTATION)

Starts the execution of a query to retrieve a day-by-day summary of invalid traffic counts for a specific platform. The results will be written to the specified BigQuery destination table. The returned operation name can be used to poll for query completion status.

The output table contains 5 rows for each day in the date range. 1 row for each of the 4 device types, and 1 row for all device types. The All row is the sum of the 4 device types for that day. As a result, each column contains twice the total of the number of impressions. If ADH redacts rows due to privacy constraints, the [filtered row summary](https://developers.google.com/ads-data-hub/guides/legacy-diff-checks#filtered_row_summary) (the row with no day) will contain the sum of redacted rows.

### HTTP request

`POST https://adsdatahub.googleapis.com/v1/{name=customers/*}:generateIvtReport`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Ads Data Hub customer making the request. This is in the form of 'customers/\[customerId\]'. e.g. 'customers/123'. |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "adsDataCustomerId": string, "startDate": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/Date`) }, "endDate": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/Date`) }, "timeZone": string, "dateDimensionGranularity": enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#DateDimensionGranularity`), "destTable": string, // Union field `platform_dimensions` can be only one of the following: "googleAdsDimensions": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#GoogleAdsDimensions`) }, "dv360YoutubeDimensions": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#Dv360Dimensions`) }, "ytReserveDimensions": { object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#YouTubeReserveDimensions`) } // End of list of possible types for union field `platform_dimensions`. } ``` |

| Fields ||
|---|---|
| `adsDataCustomerId` | `string (https://developers.google.com/discovery/v1/type-format format)` Linked Ads Data Hub customer ID that owns the ads data. |
| `startDate` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/Date`)`` The first day of the generated report. |
| `endDate` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/Date`)`` The last day of the generated report, inclusive. |
| `timeZone` | `string` Optional. The time zone for the report start and end dates. If not specified, defaults to 'UTC'. |
| `dateDimensionGranularity` | ``enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#DateDimensionGranularity`)`` Optional. The granularity of the IVT report's date dimension. Defaults to DAY if UNSPECIFIED. |
| `destTable` | `string` Destination BigQuery table for query results with the format 'project.dataset.table_name'. If specified, the project must be explicitly whitelisted for the customer's ADH account. If project is not specified, uses default project for the provided customer. If neither project nor dataset is specified, uses the default project and dataset. |
| Union field `platform_dimensions`. The platform to report on with optional platform-specific slicing. Not selecting a platform will result in an error. `platform_dimensions` can be only one of the following: ||
| `googleAdsDimensions` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#GoogleAdsDimensions`)`` Report on platform Google Ads. |
| `dv360YoutubeDimensions` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#Dv360Dimensions`)`` Report on platform DV360. |
| `ytReserveDimensions` | ``object (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#YouTubeReserveDimensions`)`` Report on platform YTR. |

### Response body

If successful, the response body contains an instance of `https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/operations#Operation`.

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/adsdatahub`

## DateDimensionGranularity

Specifies the date dimension's reporting granularity.

| Enums ||
|---|---|
| `DATE_DIMENSION_GRANULARITY_UNSPECIFIED` | Default value. This value is unused. |
| `DAY` | Each report row will represent a single day of data. |
| `ENTIRE_DATE_RANGE` | Each report row will represent the entire date range of data. |

## GoogleAdsDimensions

Filtering dimensions for Google Ads platform.

| JSON representation |
|---|
| ``` { "campaignIds": [ string ], "metricType": enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#MetricType`) } ``` |

| Fields ||
|---|---|
| `campaignIds[]` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional Google Ads campaign ids. If empty, reports on all campaigns for the specified time period. |
| `metricType` | ``enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#MetricType`)`` Designates the platform to measure and report on. |

## MetricType

Designates the platform to measure and report on.

| Enums ||
|---|---|
| `METRIC_TYPE_UNSPECIFIED` | Unspecified metric type. |
| `METRIC_TYPE_IMPRESSION` | Google Ads impression data. |
| `METRIC_TYPE_YOUTUBE_VIEW` | YouTube views a.k.a. TrueView views. |

## Dv360Dimensions

Filtering dimensions for DV360 platform.

| JSON representation |
|---|
| ``` { "lineItemIds": [ string ], "metricType": enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#MetricType`) } ``` |

| Fields ||
|---|---|
| `lineItemIds[]` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional DV360 line item ids. If empty, reports on all line items for the specified time period. |
| `metricType` | ``enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#MetricType`)`` Designates the platform to measure and report on. |

## YouTubeReserveDimensions

Filtering dimensions for YouTube Reserve platform.

| JSON representation |
|---|
| ``` { "orderIds": [ string ], "metricType": enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#MetricType`) } ``` |

| Fields ||
|---|---|
| `orderIds[]` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional YouTube Reserve order ids. If empty, reports on all orders for the specified time period. |
| `metricType` | ``enum (`https://developers.google.com/ads-data-hub/marketers/reference/rest/v1/customers/generateIvtReport#MetricType`)`` Designates the platform to measure and report on. |